Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -1626,643 +1804,921 @@
 	     */
 #ifdef DEBUG
-	    fprintf(stderr,"REFERENCE\n");
-#endif
-	    const char *refs[5]={"mimeType","encoding","schema","method","href"};
-	    for(int l=0;l<5;l++){
-#ifdef DEBUG
-	      fprintf(stderr,"*** %s ***",refs[l]);
-#endif
-	      xmlChar *val=xmlGetProp(cur2,BAD_CAST refs[l]);
-	      if(val!=NULL && xmlStrlen(val)>0){
-		if(tmpmaps->content!=NULL)
-		  addToMap(tmpmaps->content,refs[l],(char*)val);
-		else
-		  tmpmaps->content=createMap(refs[l],(char*)val);
-		map* ltmp=getMap(tmpmaps->content,"method");
-		if(l==4){
-		  if(!(ltmp!=NULL && strncmp(ltmp->value,"POST",4)==0)
-		     && CHECK_INET_HANDLE(hInternet)){
-		    if(loadRemoteFile(&m,&tmpmaps->content,&hInternet,(char*)val)!=0){
-		      freeMaps(&m);
-		      free(m);
-		      free(REQUEST);
-		      free(SERVICE_URL);
-		      InternetCloseHandle(&hInternet);
-		      freeService(&s1);
-		      free(s1);
-		      return 0;
-		    }
-		  }
-		}
-	      }
-#ifdef DEBUG
-	      fprintf(stderr,"%s\n",val);
-#endif
-	      xmlFree(val);
-	    }
+                      fprintf (stderr, "REFERENCE\n");
+#endif
+                      const char *refs[5] =
+                        { "mimeType", "encoding", "schema", "method",
+                        "href"
+                      };
+                      for (int l = 0; l < 5; l++)
+                        {
+#ifdef DEBUG
+                          fprintf (stderr, "*** %s ***", refs[l]);
+#endif
+                          xmlChar *val = xmlGetProp (cur2, BAD_CAST refs[l]);
+                          if (val != NULL && xmlStrlen (val) > 0)
+                            {
+                              if (tmpmaps->content != NULL)
+                                addToMap (tmpmaps->content, refs[l],
+                                          (char *) val);
+                              else
+                                tmpmaps->content =
+                                  createMap (refs[l], (char *) val);
+                              map *ltmp = getMap (tmpmaps->content, "method");
+                              if (l == 4)
+                                {
+                                  if (!
+                                      (ltmp != NULL
+                                       && strncmp (ltmp->value, "POST",
+                                                   4) == 0)
+                                      && CHECK_INET_HANDLE (hInternet))
+                                    {
+                                      if (loadRemoteFile
+                                          (&m, &tmpmaps->content, &hInternet,
+                                           (char *) val) != 0)
+                                        {
+                                          freeMaps (&m);
+                                          free (m);
+                                          free (REQUEST);
+                                          free (SERVICE_URL);
+                                          InternetCloseHandle (&hInternet);
+                                          freeService (&s1);
+                                          free (s1);
+                                          return 0;
+                                        }
+                                    }
+                                }
+                            }
+#ifdef DEBUG
+                          fprintf (stderr, "%s\n", val);
+#endif
+                          xmlFree (val);
+                        }
 #ifdef POST_DEBUG
-	    fprintf(stderr,"Parse Header and Body from Reference \n");
-#endif
-	    xmlNodePtr cur3=cur2->children;
-	    /*	    HINTERNET hInternetP;
-		    hInternetP=InternetOpen(
-		    #ifndef WIN32
-		    (LPCTSTR)
-		    #endif
-		    "ZooWPSClient\0",
-		    INTERNET_OPEN_TYPE_PRECONFIG,
-		    NULL,NULL, 0);*/
-	    //hInternet.ihandle[hInternet.nb].header=NULL;
-	    while(cur3!=NULL){
-	      while(cur3!=NULL && cur3->type!=XML_ELEMENT_NODE)
-		cur3=cur3->next;
-	      if(cur3==NULL)
-		break;
-	      if(xmlStrcasecmp(cur3->name,BAD_CAST "Header")==0 ){
-		const char *ha[2];
-		ha[0]="key";
-		ha[1]="value";
-		int hai;
-		char *has;
-		char *key;
-		for(hai=0;hai<2;hai++){
-		  xmlChar *val=xmlGetProp(cur3,BAD_CAST ha[hai]);
+                      fprintf (stderr,
+                               "Parse Header and Body from Reference \n");
+#endif
+                      xmlNodePtr cur3 = cur2->children;
+                      /*      HINTERNET hInternetP;
+                         hInternetP=InternetOpen(
+                         #ifndef WIN32
+                         (LPCTSTR)
+                         #endif
+                         "ZooWPSClient\0",
+                         INTERNET_OPEN_TYPE_PRECONFIG,
+                         NULL,NULL, 0); */
+                      //hInternet.ihandle[hInternet.nb].header=NULL;
+                      while (cur3 != NULL)
+                        {
+                          while (cur3 != NULL
+                                 && cur3->type != XML_ELEMENT_NODE)
+                            cur3 = cur3->next;
+                          if (cur3 == NULL)
+                            break;
+                          if (xmlStrcasecmp (cur3->name, BAD_CAST "Header") ==
+                              0)
+                            {
+                              const char *ha[2];
+                              ha[0] = "key";
+                              ha[1] = "value";
+                              int hai;
+                              char *has;
+                              char *key;
+                              for (hai = 0; hai < 2; hai++)
+                                {
+                                  xmlChar *val =
+                                    xmlGetProp (cur3, BAD_CAST ha[hai]);
 #ifdef POST_DEBUG
-		  fprintf(stderr,"%s = %s\n",ha[hai],(char*)val);
-#endif
-		  if(hai==0){
-		    key=zStrdup((char*)val);
-		  }else{
-		    has=(char*)malloc((4+xmlStrlen(val)+strlen(key))*sizeof(char));
-		    if(has == NULL){
-		      return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-		    }
-		    snprintf(has,(3+xmlStrlen(val)+strlen(key)),"%s: %s",key,(char*)val);
-		    free(key);
+                                  fprintf (stderr, "%s = %s\n", ha[hai],
+                                           (char *) val);
+#endif
+                                  if (hai == 0)
+                                    {
+                                      key = zStrdup ((char *) val);
+                                    }
+                                  else
+                                    {
+                                      has =
+                                        (char *)
+                                        malloc ((4 + xmlStrlen (val) +
+                                                 strlen (key)) *
+                                                sizeof (char));
+                                      if (has == NULL)
+                                        {
+                                          return errorException (m,
+                                                                 _
+                                                                 ("Unable to allocate memory."),
+                                                                 "InternalError",
+                                                                 NULL);
+                                        }
+                                      snprintf (has,
+                                                (3 + xmlStrlen (val) +
+                                                 strlen (key)), "%s: %s", key,
+                                                (char *) val);
+                                      free (key);
 #ifdef POST_DEBUG
-		    fprintf(stderr,"%s\n",has);
-#endif
-		  }
-		  xmlFree(val);
-		}
-		hInternet.ihandle[hInternet.nb].header=curl_slist_append(hInternet.ihandle[hInternet.nb].header, has);
-		if(has!=NULL)
-		  free(has);
-	      }
-	      else{
+                                      fprintf (stderr, "%s\n", has);
+#endif
+                                    }
+                                  xmlFree (val);
+                                }
+                              hInternet.ihandle[hInternet.nb].header =
+                                curl_slist_append (hInternet.ihandle
+                                                   [hInternet.nb].header,
+                                                   has);
+                              if (has != NULL)
+                                free (has);
+                            }
+                          else
+                            {
 #ifdef POST_DEBUG
-		fprintf(stderr,"Try to fetch the body part of the request ...\n");
-#endif
-		if(xmlStrcasecmp(cur3->name,BAD_CAST "Body")==0 ){
+                              fprintf (stderr,
+                                       "Try to fetch the body part of the request ...\n");
+#endif
+                              if (xmlStrcasecmp (cur3->name, BAD_CAST "Body")
+                                  == 0)
+                                {
 #ifdef POST_DEBUG
-		  fprintf(stderr,"Body part found !!!\n",(char*)cur3->content);
-#endif
-		  char *tmp=(char*)malloc(cgiContentLength+1*sizeof(char));
-		  memset(tmp,0,cgiContentLength);
-		  xmlNodePtr cur4=cur3->children;
-		  while(cur4!=NULL){
-		    while(cur4->type!=XML_ELEMENT_NODE)
-		      cur4=cur4->next;
-		    xmlDocPtr bdoc = xmlNewDoc(BAD_CAST "1.0");
-		    bdoc->encoding = xmlCharStrdup ("UTF-8");
-		    xmlDocSetRootElement(bdoc,cur4);
-		    xmlChar* btmps;
-		    int bsize;
-		    xmlDocDumpMemory(bdoc,&btmps,&bsize);
+                                  fprintf (stderr, "Body part found !!!\n",
+                                           (char *) cur3->content);
+#endif
+                                  char *tmp =
+                                    (char *) malloc (cgiContentLength +
+                                                     1 * sizeof (char));
+                                  memset (tmp, 0, cgiContentLength);
+                                  xmlNodePtr cur4 = cur3->children;
+                                  while (cur4 != NULL)
+                                    {
+                                      while (cur4->type != XML_ELEMENT_NODE)
+                                        cur4 = cur4->next;
+                                      xmlDocPtr bdoc =
+                                        xmlNewDoc (BAD_CAST "1.0");
+                                      bdoc->encoding =
+                                        xmlCharStrdup ("UTF-8");
+                                      xmlDocSetRootElement (bdoc, cur4);
+                                      xmlChar *btmps;
+                                      int bsize;
+                                      xmlDocDumpMemory (bdoc, &btmps, &bsize);
 #ifdef POST_DEBUG
-		    fprintf(stderr,"Body part found !!! %s %s\n",tmp,(char*)btmps);
-#endif
-		    if(btmps!=NULL)
-		      sprintf(tmp,"%s",(char*)btmps);
-		    xmlFree(btmps);
-		    cur4=cur4->next;
-		    xmlFreeDoc(bdoc);
-		  }
-		  map *btmp=getMap(tmpmaps->content,"href");
-		  if(btmp!=NULL){
+                                      fprintf (stderr,
+                                               "Body part found !!! %s %s\n",
+                                               tmp, (char *) btmps);
+#endif
+                                      if (btmps != NULL)
+                                        sprintf (tmp, "%s", (char *) btmps);
+                                      xmlFree (btmps);
+                                      cur4 = cur4->next;
+                                      xmlFreeDoc (bdoc);
+                                    }
+                                  map *btmp =
+                                    getMap (tmpmaps->content, "href");
+                                  if (btmp != NULL)
+                                    {
 #ifdef POST_DEBUG
-		    fprintf(stderr,"%s %s\n",btmp->value,tmp);
-		    curl_easy_setopt(hInternet.handle, CURLOPT_VERBOSE, 1);
-#endif
-		    hInternet.waitingRequests[hInternet.nb]=strdup(tmp);
-		    InternetOpenUrl(&hInternet,btmp->value,hInternet.waitingRequests[hInternet.nb],strlen(hInternet.waitingRequests[hInternet.nb]),
-				    INTERNET_FLAG_NO_CACHE_WRITE,0);
-		  }
-		  free(tmp);
-		}
-		else
-		  if(xmlStrcasecmp(cur3->name,BAD_CAST "BodyReference")==0 ){
-		    xmlChar *val=xmlGetProp(cur3,BAD_CAST "href");
-		    HINTERNET bInternet,res1;
-		    bInternet=InternetOpen(
+                                      fprintf (stderr, "%s %s\n", btmp->value,
+                                               tmp);
+                                      curl_easy_setopt (hInternet.handle,
+                                                        CURLOPT_VERBOSE, 1);
+#endif
+                                      hInternet.waitingRequests[hInternet.
+                                                                nb] =
+                                        strdup (tmp);
+                                      InternetOpenUrl (&hInternet,
+                                                       btmp->value,
+                                                       hInternet.
+                                                       waitingRequests
+                                                       [hInternet.nb],
+                                                       strlen (hInternet.
+                                                               waitingRequests
+                                                               [hInternet.
+                                                                nb]),
+                                                       INTERNET_FLAG_NO_CACHE_WRITE,
+                                                       0);
+                                    }
+                                  free (tmp);
+                                }
+                              else
+                                if (xmlStrcasecmp
+                                    (cur3->name,
+                                     BAD_CAST "BodyReference") == 0)
+                                {
+                                  xmlChar *val =
+                                    xmlGetProp (cur3, BAD_CAST "href");
+                                  HINTERNET bInternet, res1;
+                                  bInternet = InternetOpen (
 #ifndef WIN32
-					   (LPCTSTR)
-#endif
-					   "ZooWPSClient\0",
-					   INTERNET_OPEN_TYPE_PRECONFIG,
-					   NULL,NULL, 0);
-		    if(!CHECK_INET_HANDLE(hInternet))
-		      fprintf(stderr,"WARNING : hInternet handle failed to initialize");
+                                                             (LPCTSTR)
+#endif
+                                                             "ZooWPSClient\0",
+                                                             INTERNET_OPEN_TYPE_PRECONFIG,
+                                                             NULL, NULL, 0);
+                                  if (!CHECK_INET_HANDLE (hInternet))
+                                    fprintf (stderr,
+                                             "WARNING : hInternet handle failed to initialize");
 #ifdef POST_DEBUG
-		    curl_easy_setopt(bInternet.handle, CURLOPT_VERBOSE, 1);
-#endif
-		    bInternet.waitingRequests[0]=strdup((char*)val);
-		    res1=InternetOpenUrl(&bInternet,bInternet.waitingRequests[0],NULL,0,
-					 INTERNET_FLAG_NO_CACHE_WRITE,0);
-		    processDownloads(&bInternet);
-		    char* tmp=
-		      (char*)malloc((bInternet.ihandle[0].nDataLen+1)*sizeof(char));
-		    if(tmp == NULL){
-		      return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-		    }
-		    size_t bRead;
-		    InternetReadFile(bInternet.ihandle[0], (LPVOID)tmp,
-				     bInternet.ihandle[0].nDataLen, &bRead);
-		    tmp[bInternet.ihandle[0].nDataLen]=0;
-		    InternetCloseHandle(&bInternet);
-		    map *btmp=getMap(tmpmaps->content,"href");
-		    if(btmp!=NULL){
+                                  curl_easy_setopt (bInternet.handle,
+                                                    CURLOPT_VERBOSE, 1);
+#endif
+                                  bInternet.waitingRequests[0] =
+                                    strdup ((char *) val);
+                                  res1 =
+                                    InternetOpenUrl (&bInternet,
+                                                     bInternet.waitingRequests
+                                                     [0], NULL, 0,
+                                                     INTERNET_FLAG_NO_CACHE_WRITE,
+                                                     0);
+                                  processDownloads (&bInternet);
+                                  char *tmp =
+                                    (char *)
+                                    malloc ((bInternet.ihandle[0].nDataLen +
+                                             1) * sizeof (char));
+                                  if (tmp == NULL)
+                                    {
+                                      return errorException (m,
+                                                             _
+                                                             ("Unable to allocate memory."),
+                                                             "InternalError",
+                                                             NULL);
+                                    }
+                                  size_t bRead;
+                                  InternetReadFile (bInternet.ihandle[0],
+                                                    (LPVOID) tmp,
+                                                    bInternet.ihandle[0].
+                                                    nDataLen, &bRead);
+                                  tmp[bInternet.ihandle[0].nDataLen] = 0;
+                                  InternetCloseHandle (&bInternet);
+                                  map *btmp =
+                                    getMap (tmpmaps->content, "href");
+                                  if (btmp != NULL)
+                                    {
 #ifdef POST_DEBUG
-		      fprintf(stderr,"%s %s\n",btmp->value,tmp);
-#endif
-		      hInternet.waitingRequests[hInternet.nb]=strdup(tmp);
-		      res=InternetOpenUrl(&hInternet,btmp->value,hInternet.waitingRequests[hInternet.nb],
-					  strlen(hInternet.waitingRequests[hInternet.nb]),
-					  INTERNET_FLAG_NO_CACHE_WRITE,0);
-		    }
-		    free(tmp);
-		  }
-	      }
-	      cur3=cur3->next;
-	    }
+                                      fprintf (stderr, "%s %s\n", btmp->value,
+                                               tmp);
+#endif
+                                      hInternet.waitingRequests[hInternet.
+                                                                nb] =
+                                        strdup (tmp);
+                                      res =
+                                        InternetOpenUrl (&hInternet,
+                                                         btmp->value,
+                                                         hInternet.
+                                                         waitingRequests
+                                                         [hInternet.nb],
+                                                         strlen (hInternet.
+                                                                 waitingRequests
+                                                                 [hInternet.
+                                                                  nb]),
+                                                         INTERNET_FLAG_NO_CACHE_WRITE,
+                                                         0);
+                                    }
+                                  free (tmp);
+                                }
+                            }
+                          cur3 = cur3->next;
+                        }
 #ifdef POST_DEBUG
-	    fprintf(stderr,"Header and Body was parsed from Reference \n");
-#endif
-#ifdef DEBUG
-	    dumpMap(tmpmaps->content);
-	    fprintf(stderr, "= element 2 node \"%s\" = (%s)\n", 
-		    cur2->name,cur2->content);
-#endif
-	  }
-	  else if(xmlStrcasecmp(cur2->name,BAD_CAST "Data")==0){
-#ifdef DEBUG
-	    fprintf(stderr,"DATA\n");
-#endif
-	    xmlNodePtr cur4=cur2->children;
-	    while(cur4!=NULL){
-	      while(cur4!=NULL &&cur4->type!=XML_ELEMENT_NODE)
-		cur4=cur4->next;
-	      if(cur4==NULL)
-		break;
-	      if(xmlStrcasecmp(cur4->name, BAD_CAST "LiteralData")==0){
-		/**
+                      fprintf (stderr,
+                               "Header and Body was parsed from Reference \n");
+#endif
+#ifdef DEBUG
+                      dumpMap (tmpmaps->content);
+                      fprintf (stderr, "= element 2 node \"%s\" = (%s)\n",
+                               cur2->name, cur2->content);
+#endif
+                    }
+                  else if (xmlStrcasecmp (cur2->name, BAD_CAST "Data") == 0)
+                    {
+#ifdef DEBUG
+                      fprintf (stderr, "DATA\n");
+#endif
+                      xmlNodePtr cur4 = cur2->children;
+                      while (cur4 != NULL)
+                        {
+                          while (cur4 != NULL
+                                 && cur4->type != XML_ELEMENT_NODE)
+                            cur4 = cur4->next;
+                          if (cur4 == NULL)
+                            break;
+                          if (xmlStrcasecmp
+                              (cur4->name, BAD_CAST "LiteralData") == 0)
+                            {
+                /**
 		 * Get every attribute from a LiteralData node
 		 * dataType , uom
 		 */
-		char *list[2];
-		list[0]=zStrdup("dataType");
-		list[1]=zStrdup("uom");
-		for(int l=0;l<2;l++){
-#ifdef DEBUG
-		  fprintf(stderr,"*** LiteralData %s ***",list[l]);
-#endif
-		  xmlChar *val=xmlGetProp(cur4,BAD_CAST list[l]);
-		  if(val!=NULL && strlen((char*)val)>0){
-		    if(tmpmaps->content!=NULL)
-		      addToMap(tmpmaps->content,list[l],(char*)val);
-		    else
-		      tmpmaps->content=createMap(list[l],(char*)val);
-#ifdef DEBUG
-		    fprintf(stderr,"%s\n",val);
-#endif
-		  }
-		  xmlFree(val);
-		  free(list[l]);		  
-		}
-	      }
-	      else if(xmlStrcasecmp(cur4->name, BAD_CAST "ComplexData")==0){
-		/**
+                              char *list[2];
+                              list[0] = zStrdup ("dataType");
+                              list[1] = zStrdup ("uom");
+                              for (int l = 0; l < 2; l++)
+                                {
+#ifdef DEBUG
+                                  fprintf (stderr, "*** LiteralData %s ***",
+                                           list[l]);
+#endif
+                                  xmlChar *val =
+                                    xmlGetProp (cur4, BAD_CAST list[l]);
+                                  if (val != NULL
+                                      && strlen ((char *) val) > 0)
+                                    {
+                                      if (tmpmaps->content != NULL)
+                                        addToMap (tmpmaps->content, list[l],
+                                                  (char *) val);
+                                      else
+                                        tmpmaps->content =
+                                          createMap (list[l], (char *) val);
+#ifdef DEBUG
+                                      fprintf (stderr, "%s\n", val);
+#endif
+                                    }
+                                  xmlFree (val);
+                                  free (list[l]);
+                                }
+                            }
+                          else
+                            if (xmlStrcasecmp
+                                (cur4->name, BAD_CAST "ComplexData") == 0)
+                            {
+                /**
 		 * Get every attribute from a Reference node
 		 * mimeType, encoding, schema
 		 */
-		const char *coms[3]={"mimeType","encoding","schema"};
-		for(int l=0;l<3;l++){
-#ifdef DEBUG
-		  fprintf(stderr,"*** ComplexData %s ***\n",coms[l]);
-#endif
-		  xmlChar *val=xmlGetProp(cur4,BAD_CAST coms[l]);
-		  if(val!=NULL && strlen((char*)val)>0){
-		    if(tmpmaps->content!=NULL)
-		      addToMap(tmpmaps->content,coms[l],(char*)val);
-		    else
-		      tmpmaps->content=createMap(coms[l],(char*)val);
-#ifdef DEBUG
-		    fprintf(stderr,"%s\n",val);
-#endif
-		  }
-		  xmlFree(val);
-		}
-	      }
-
-	      map* test=getMap(tmpmaps->content,"encoding");
-	      if(test==NULL){
-		if(tmpmaps->content!=NULL)
-		  addToMap(tmpmaps->content,"encoding","utf-8");
-		else
-		  tmpmaps->content=createMap("encoding","utf-8");
-		test=getMap(tmpmaps->content,"encoding");
-	      }
-
-	      if(strcasecmp(test->value,"base64")!=0){
-		xmlChar* mv=xmlNodeListGetString(doc,cur4->xmlChildrenNode,1);
-		map* ltmp=getMap(tmpmaps->content,"mimeType");
-		if(mv==NULL || 
-		   (xmlStrcasecmp(cur4->name, BAD_CAST "ComplexData")==0 &&
-		    (ltmp==NULL || strncasecmp(ltmp->value,"text/xml",8)==0) )){
-		  xmlDocPtr doc1=xmlNewDoc(BAD_CAST "1.0");
-		  int buffersize;
-		  xmlNodePtr cur5=cur4->children;
-		  while(cur5!=NULL && cur5->type!=XML_ELEMENT_NODE && cur5->type!=XML_CDATA_SECTION_NODE)
-		    cur5=cur5->next;
-		  if(cur5!=NULL && cur5->type!=XML_CDATA_SECTION_NODE){
-		    xmlDocSetRootElement(doc1,cur5);
-		    xmlDocDumpFormatMemoryEnc(doc1, &mv, &buffersize, "utf-8", 1);
-		    char size[1024];
-		    sprintf(size,"%d",buffersize);
-		    addToMap(tmpmaps->content,"size",size);
-		    xmlFreeDoc(doc1);
-		  }
-		}
-		if(mv!=NULL){
-		  addToMap(tmpmaps->content,"value",(char*)mv);
-		  xmlFree(mv);
-		}
-	      }else{
-		xmlChar* tmp=xmlNodeListGetRawString(doc,cur4->xmlChildrenNode,0);
-		addToMap(tmpmaps->content,"value",(char*)tmp);
-		map* tmpv=getMap(tmpmaps->content,"value");
-		char *res=NULL;
-		char *curs=tmpv->value;
-		for(int i=0;i<=strlen(tmpv->value)/64;i++) {
-		  if(res==NULL)
-		    res=(char*)malloc(67*sizeof(char));
-		  else
-		    res=(char*)realloc(res,(((i+1)*65)+i)*sizeof(char));
-		  int csize=i*65;
-		  strncpy(res + csize,curs,64);
-		  if(i==xmlStrlen(tmp)/64)
-		    strcat(res,"\n\0");
-		  else{
-		    strncpy(res + (((i+1)*64)+i),"\n\0",2);
-		    curs+=64;
-		  }
-		}
-		free(tmpv->value);
-		tmpv->value=zStrdup(res);
-		free(res);
-		xmlFree(tmp);
-	      }
-	      cur4=cur4->next;
-	    }
-	  }
-#ifdef DEBUG
-	  fprintf(stderr,"cur2 next \n");
-	  fflush(stderr);
-#endif
-	  cur2=cur2->next;
-	}
-#ifdef DEBUG
-	fprintf(stderr,"ADD MAPS TO REQUEST MAPS !\n");
-	fflush(stderr);
-#endif
-
-	{
-	  maps* testPresence=getMaps(request_input_real_format,tmpmaps->name);
-	  if(testPresence!=NULL){
-	    elements* elem=getElements(s1->inputs,tmpmaps->name);
-	    if(elem!=NULL){
-	      if(appendMapsToMaps(m,request_input_real_format,tmpmaps,elem)<0){
-		freeMaps(&m);
-		free(m);
-		free(REQUEST);
-		free(SERVICE_URL);
-		InternetCloseHandle(&hInternet);
-		freeService(&s1);
-		free(s1);
-		return 0;
-	      }
-	    }
-	  }
-	  else
-	    addMapsToMaps(&request_input_real_format,tmpmaps);
-	}
-
-#ifdef DEBUG
-	fprintf(stderr,"******TMPMAPS*****\n");
-	dumpMaps(tmpmaps);
-	fprintf(stderr,"******REQUESTMAPS*****\n");
-	dumpMaps(request_input_real_format);
-#endif
-	freeMaps(&tmpmaps);
-	free(tmpmaps);
-	tmpmaps=NULL;	      
-      }
-#ifdef DEBUG
-      dumpMaps(tmpmaps); 
-#endif
-    }
-#ifdef DEBUG
-    fprintf(stderr,"Search for response document node\n");
-#endif
-    xmlXPathFreeObject(tmpsptr);
-    
-    tmpsptr=extractFromDoc(doc,"/*/*/*[local-name()='ResponseDocument']");
-    bool asRaw=false;
-    tmps=tmpsptr->nodesetval;
-    if(tmps->nodeNr==0){
-      tmpsptr=extractFromDoc(doc,"/*/*/*[local-name()='RawDataOutput']");
-      tmps=tmpsptr->nodesetval;
-      asRaw=true;
-    }
-#ifdef DEBUG
-    fprintf(stderr,"*****%d*****\n",tmps->nodeNr);
-#endif
-    if(asRaw==true){
-      addToMap(request_inputs,"RawDataOutput","");
-      xmlNodePtr cur0=tmps->nodeTab[0];
-      if(cur0->type == XML_ELEMENT_NODE) {
-	
-	maps* tmpmaps=(maps*)malloc(MAPS_SIZE);
-	if(tmpmaps == NULL){
-	  return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-	}
-	tmpmaps->name=zStrdup("unknownIdentifier");
-	tmpmaps->content=NULL;
-	tmpmaps->next=NULL;
-	
-	/**
+                              const char *coms[3] =
+                                { "mimeType", "encoding", "schema" };
+                              for (int l = 0; l < 3; l++)
+                                {
+#ifdef DEBUG
+                                  fprintf (stderr, "*** ComplexData %s ***\n",
+                                           coms[l]);
+#endif
+                                  xmlChar *val =
+                                    xmlGetProp (cur4, BAD_CAST coms[l]);
+                                  if (val != NULL
+                                      && strlen ((char *) val) > 0)
+                                    {
+                                      if (tmpmaps->content != NULL)
+                                        addToMap (tmpmaps->content, coms[l],
+                                                  (char *) val);
+                                      else
+                                        tmpmaps->content =
+                                          createMap (coms[l], (char *) val);
+#ifdef DEBUG
+                                      fprintf (stderr, "%s\n", val);
+#endif
+                                    }
+                                  xmlFree (val);
+                                }
+                            }
+
+                          map *test = getMap (tmpmaps->content, "encoding");
+                          if (test == NULL)
+                            {
+                              if (tmpmaps->content != NULL)
+                                addToMap (tmpmaps->content, "encoding",
+                                          "utf-8");
+                              else
+                                tmpmaps->content =
+                                  createMap ("encoding", "utf-8");
+                              test = getMap (tmpmaps->content, "encoding");
+                            }
+
+                          if (strcasecmp (test->value, "base64") != 0)
+                            {
+                              xmlChar *mv = xmlNodeListGetString (doc,
+                                                                  cur4->xmlChildrenNode,
+                                                                  1);
+                              map *ltmp =
+                                getMap (tmpmaps->content, "mimeType");
+                              if (mv == NULL
+                                  ||
+                                  (xmlStrcasecmp
+                                   (cur4->name, BAD_CAST "ComplexData") == 0
+                                   && (ltmp == NULL
+                                       || strncasecmp (ltmp->value,
+                                                       "text/xml", 8) == 0)))
+                                {
+                                  xmlDocPtr doc1 = xmlNewDoc (BAD_CAST "1.0");
+                                  int buffersize;
+                                  xmlNodePtr cur5 = cur4->children;
+                                  while (cur5 != NULL
+                                         && cur5->type != XML_ELEMENT_NODE
+                                         && cur5->type !=
+                                         XML_CDATA_SECTION_NODE)
+                                    cur5 = cur5->next;
+                                  if (cur5 != NULL
+                                      && cur5->type != XML_CDATA_SECTION_NODE)
+                                    {
+                                      xmlDocSetRootElement (doc1, cur5);
+                                      xmlDocDumpFormatMemoryEnc (doc1, &mv,
+                                                                 &buffersize,
+                                                                 "utf-8", 1);
+                                      char size[1024];
+                                      sprintf (size, "%d", buffersize);
+                                      addToMap (tmpmaps->content, "size",
+                                                size);
+                                      xmlFreeDoc (doc1);
+                                    }
+                                }
+                              if (mv != NULL)
+                                {
+                                  addToMap (tmpmaps->content, "value",
+                                            (char *) mv);
+                                  xmlFree (mv);
+                                }
+                            }
+                          else
+                            {
+                              xmlChar *tmp = xmlNodeListGetRawString (doc,
+                                                                      cur4->
+                                                                      xmlChildrenNode,
+                                                                      0);
+                              addToMap (tmpmaps->content, "value",
+                                        (char *) tmp);
+                              map *tmpv = getMap (tmpmaps->content, "value");
+                              char *res = NULL;
+                              char *curs = tmpv->value;
+                              for (int i = 0; i <= strlen (tmpv->value) / 64;
+                                   i++)
+                                {
+                                  if (res == NULL)
+                                    res =
+                                      (char *) malloc (67 * sizeof (char));
+                                  else
+                                    res =
+                                      (char *) realloc (res,
+                                                        (((i + 1) * 65) +
+                                                         i) * sizeof (char));
+                                  int csize = i * 65;
+                                  strncpy (res + csize, curs, 64);
+                                  if (i == xmlStrlen (tmp) / 64)
+                                    strcat (res, "\n\0");
+                                  else
+                                    {
+                                      strncpy (res + (((i + 1) * 64) + i),
+                                               "\n\0", 2);
+                                      curs += 64;
+                                    }
+                                }
+                              free (tmpv->value);
+                              tmpv->value = zStrdup (res);
+                              free (res);
+                              xmlFree (tmp);
+                            }
+                          cur4 = cur4->next;
+                        }
+                    }
+#ifdef DEBUG
+                  fprintf (stderr, "cur2 next \n");
+                  fflush (stderr);
+#endif
+                  cur2 = cur2->next;
+                }
+#ifdef DEBUG
+              fprintf (stderr, "ADD MAPS TO REQUEST MAPS !\n");
+              fflush (stderr);
+#endif
+
+              {
+                maps *testPresence =
+                  getMaps (request_input_real_format, tmpmaps->name);
+                if (testPresence != NULL)
+                  {
+                    elements *elem = getElements (s1->inputs, tmpmaps->name);
+                    if (elem != NULL)
+                      {
+                        if (appendMapsToMaps
+                            (m, request_input_real_format, tmpmaps, elem) < 0)
+                          {
+                            freeMaps (&m);
+                            free (m);
+                            free (REQUEST);
+                            free (SERVICE_URL);
+                            InternetCloseHandle (&hInternet);
+                            freeService (&s1);
+                            free (s1);
+                            return 0;
+                          }
+                      }
+                  }
+                else
+                  addMapsToMaps (&request_input_real_format, tmpmaps);
+              }
+
+#ifdef DEBUG
+              fprintf (stderr, "******TMPMAPS*****\n");
+              dumpMaps (tmpmaps);
+              fprintf (stderr, "******REQUESTMAPS*****\n");
+              dumpMaps (request_input_real_format);
+#endif
+              freeMaps (&tmpmaps);
+              free (tmpmaps);
+              tmpmaps = NULL;
+            }
+#ifdef DEBUG
+          dumpMaps (tmpmaps);
+#endif
+        }
+#ifdef DEBUG
+      fprintf (stderr, "Search for response document node\n");
+#endif
+      xmlXPathFreeObject (tmpsptr);
+
+      tmpsptr =
+        extractFromDoc (doc, "/*/*/*[local-name()='ResponseDocument']");
+      bool asRaw = false;
+      tmps = tmpsptr->nodesetval;
+      if (tmps->nodeNr == 0)
+        {
+          tmpsptr =
+            extractFromDoc (doc, "/*/*/*[local-name()='RawDataOutput']");
+          tmps = tmpsptr->nodesetval;
+          asRaw = true;
+        }
+#ifdef DEBUG
+      fprintf (stderr, "*****%d*****\n", tmps->nodeNr);
+#endif
+      if (asRaw == true)
+        {
+          addToMap (request_inputs, "RawDataOutput", "");
+          xmlNodePtr cur0 = tmps->nodeTab[0];
+          if (cur0->type == XML_ELEMENT_NODE)
+            {
+
+              maps *tmpmaps = (maps *) malloc (MAPS_SIZE);
+              if (tmpmaps == NULL)
+                {
+                  return errorException (m, _("Unable to allocate memory."),
+                                         "InternalError", NULL);
+                }
+              tmpmaps->name = zStrdup ("unknownIdentifier");
+              tmpmaps->content = NULL;
+              tmpmaps->next = NULL;
+
+        /**
 	 * Get every attribute from a RawDataOutput node
 	 * mimeType, encoding, schema, uom
 	 */
-	const char *outs[4]={"mimeType","encoding","schema","uom"};
-	for(int l=0;l<4;l++){
-#ifdef DEBUG
-	  fprintf(stderr,"*** %s ***\t",outs[l]);
-#endif
-	  xmlChar *val=xmlGetProp(cur0,BAD_CAST outs[l]);
-	  if(val!=NULL){
-	    if(strlen((char*)val)>0){
-	      if(tmpmaps->content!=NULL)
-		addToMap(tmpmaps->content,outs[l],(char*)val);
-	      else
-		tmpmaps->content=createMap(outs[l],(char*)val);
-	    }
-	    xmlFree(val);
-	  }
-	}
-	xmlNodePtr cur2=cur0->children;
-	while(cur2!=NULL && cur2->type != XML_ELEMENT_NODE)
-	  cur2=cur2->next;
-	int cur1cnt=0;
-	while(cur2!=NULL){
-	  if(xmlStrncasecmp(cur2->name,BAD_CAST "Identifier",xmlStrlen(cur2->name))==0){
-	    xmlChar *val=
-	      xmlNodeListGetString(NULL,cur2->xmlChildrenNode,1);
-	    free(tmpmaps->name);
-	    tmpmaps->name=zStrdup((char*)val);
-	  }
-	  cur2=cur2->next;
-	  while(cur2!=NULL && cur2->type != XML_ELEMENT_NODE)
-	    cur2=cur2->next;
-	}
-	if(request_output_real_format==NULL)
-	  request_output_real_format=dupMaps(&tmpmaps);
-	else
-	  addMapsToMaps(&request_output_real_format,tmpmaps);
-	if(tmpmaps!=NULL){
-	  freeMaps(&tmpmaps);
-	  free(tmpmaps);
-	  tmpmaps=NULL;
-	}
-      }
-    }
-    else
-      for(int k=0;k<tmps->nodeNr;k++){
-	//else
-	addToMap(request_inputs,"ResponseDocument","");
-	maps *tmpmaps=NULL;
-	xmlNodePtr cur=tmps->nodeTab[k];
-	if(cur->type == XML_ELEMENT_NODE) {
-	  /**
+              const char *outs[4] =
+                { "mimeType", "encoding", "schema", "uom" };
+              for (int l = 0; l < 4; l++)
+                {
+#ifdef DEBUG
+                  fprintf (stderr, "*** %s ***\t", outs[l]);
+#endif
+                  xmlChar *val = xmlGetProp (cur0, BAD_CAST outs[l]);
+                  if (val != NULL)
+                    {
+                      if (strlen ((char *) val) > 0)
+                        {
+                          if (tmpmaps->content != NULL)
+                            addToMap (tmpmaps->content, outs[l],
+                                      (char *) val);
+                          else
+                            tmpmaps->content =
+                              createMap (outs[l], (char *) val);
+                        }
+                      xmlFree (val);
+                    }
+                }
+              xmlNodePtr cur2 = cur0->children;
+              while (cur2 != NULL && cur2->type != XML_ELEMENT_NODE)
+                cur2 = cur2->next;
+              int cur1cnt = 0;
+              while (cur2 != NULL)
+                {
+                  if (xmlStrncasecmp
+                      (cur2->name, BAD_CAST "Identifier",
+                       xmlStrlen (cur2->name)) == 0)
+                    {
+                      xmlChar *val =
+                        xmlNodeListGetString (NULL, cur2->xmlChildrenNode, 1);
+                      free (tmpmaps->name);
+                      tmpmaps->name = zStrdup ((char *) val);
+                    }
+                  cur2 = cur2->next;
+                  while (cur2 != NULL && cur2->type != XML_ELEMENT_NODE)
+                    cur2 = cur2->next;
+                }
+              if (request_output_real_format == NULL)
+                request_output_real_format = dupMaps (&tmpmaps);
+              else
+                addMapsToMaps (&request_output_real_format, tmpmaps);
+              if (tmpmaps != NULL)
+                {
+                  freeMaps (&tmpmaps);
+                  free (tmpmaps);
+                  tmpmaps = NULL;
+                }
+            }
+        }
+      else
+        for (int k = 0; k < tmps->nodeNr; k++)
+          {
+            //else
+            addToMap (request_inputs, "ResponseDocument", "");
+            maps *tmpmaps = NULL;
+            xmlNodePtr cur = tmps->nodeTab[k];
+            if (cur->type == XML_ELEMENT_NODE)
+              {
+          /**
 	   * A specific responseDocument node.
 	   */
-	  if(tmpmaps==NULL){
-	    tmpmaps=(maps*)malloc(MAPS_SIZE);
-	    if(tmpmaps == NULL){
-	      return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-	    }
-	    tmpmaps->name=zStrdup("unknownIdentifier");
-	    tmpmaps->content=NULL;
-	    tmpmaps->next=NULL;
-	  }
-	  /**
+                if (tmpmaps == NULL)
+                  {
+                    tmpmaps = (maps *) malloc (MAPS_SIZE);
+                    if (tmpmaps == NULL)
+                      {
+                        return errorException (m,
+                                               _
+                                               ("Unable to allocate memory."),
+                                               "InternalError", NULL);
+                      }
+                    tmpmaps->name = zStrdup ("unknownIdentifier");
+                    tmpmaps->content = NULL;
+                    tmpmaps->next = NULL;
+                  }
+          /**
 	   * Get every attribute: storeExecuteResponse, lineage, status
 	   */
-	  const char *ress[3]={"storeExecuteResponse","lineage","status"};
-	  xmlChar *val;
-	  for(int l=0;l<3;l++){
-#ifdef DEBUG
-	    fprintf(stderr,"*** %s ***\t",ress[l]);
-#endif
-	    val=xmlGetProp(cur,BAD_CAST ress[l]);
-	    if(val!=NULL && strlen((char*)val)>0){
-	      if(tmpmaps->content!=NULL)
-		addToMap(tmpmaps->content,ress[l],(char*)val);
-	      else
-		tmpmaps->content=createMap(ress[l],(char*)val);
-	      addToMap(request_inputs,ress[l],(char*)val);
-	    }
-#ifdef DEBUG
-	    fprintf(stderr,"%s\n",val);
-#endif
-	    xmlFree(val);
-	  }
-	  xmlNodePtr cur1=cur->children;
-	  while(cur1!=NULL && cur1->type != XML_ELEMENT_NODE)
-	    cur1=cur1->next;
-	  int cur1cnt=0;
-	  while(cur1){
-	    /**
+                const char *ress[3] =
+                  { "storeExecuteResponse", "lineage", "status" };
+                xmlChar *val;
+                for (int l = 0; l < 3; l++)
+                  {
+#ifdef DEBUG
+                    fprintf (stderr, "*** %s ***\t", ress[l]);
+#endif
+                    val = xmlGetProp (cur, BAD_CAST ress[l]);
+                    if (val != NULL && strlen ((char *) val) > 0)
+                      {
+                        if (tmpmaps->content != NULL)
+                          addToMap (tmpmaps->content, ress[l], (char *) val);
+                        else
+                          tmpmaps->content =
+                            createMap (ress[l], (char *) val);
+                        addToMap (request_inputs, ress[l], (char *) val);
+                      }
+#ifdef DEBUG
+                    fprintf (stderr, "%s\n", val);
+#endif
+                    xmlFree (val);
+                  }
+                xmlNodePtr cur1 = cur->children;
+                while (cur1 != NULL && cur1->type != XML_ELEMENT_NODE)
+                  cur1 = cur1->next;
+                int cur1cnt = 0;
+                while (cur1)
+                  {
+            /**
 	     * Indentifier
 	     */
-	    if(xmlStrncasecmp(cur1->name,BAD_CAST "Identifier",xmlStrlen(cur1->name))==0){
-	      xmlChar *val=
-		xmlNodeListGetString(doc,cur1->xmlChildrenNode,1);
-	      if(tmpmaps==NULL){
-		tmpmaps=(maps*)malloc(MAPS_SIZE);
-		if(tmpmaps == NULL){
-		  return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-		}
-		tmpmaps->name=zStrdup((char*)val);
-		tmpmaps->content=NULL;
-		tmpmaps->next=NULL;
-	      }
-	      else{
-		free(tmpmaps->name);
-		tmpmaps->name=zStrdup((char*)val);
-	      }
-	      if(asRaw==true)
-		addToMap(request_inputs,"RawDataOutput",(char*)val);
-	      else{
-		if(cur1cnt==0)
-		  addToMap(request_inputs,"ResponseDocument",(char*)val);
-		else{
-		  map* tt=getMap(request_inputs,"ResponseDocument");
-		  char* tmp=zStrdup(tt->value);
-		  free(tt->value);
-		  tt->value=(char*)malloc((strlen(tmp)+strlen((char*)val)+1)*sizeof(char));
-		  sprintf(tt->value,"%s;%s",tmp,(char*)val);
-		  free(tmp);
-		}
-	      }
-	      cur1cnt+=1;
-	      xmlFree(val);
-	    }
-	    /**
+                    if (xmlStrncasecmp
+                        (cur1->name, BAD_CAST "Identifier",
+                         xmlStrlen (cur1->name)) == 0)
+                      {
+                        xmlChar *val =
+                          xmlNodeListGetString (doc, cur1->xmlChildrenNode,
+                                                1);
+                        if (tmpmaps == NULL)
+                          {
+                            tmpmaps = (maps *) malloc (MAPS_SIZE);
+                            if (tmpmaps == NULL)
+                              {
+                                return errorException (m,
+                                                       _
+                                                       ("Unable to allocate memory."),
+                                                       "InternalError", NULL);
+                              }
+                            tmpmaps->name = zStrdup ((char *) val);
+                            tmpmaps->content = NULL;
+                            tmpmaps->next = NULL;
+                          }
+                        else
+                          {
+                            free (tmpmaps->name);
+                            tmpmaps->name = zStrdup ((char *) val);
+                          }
+                        if (asRaw == true)
+                          addToMap (request_inputs, "RawDataOutput",
+                                    (char *) val);
+                        else
+                          {
+                            if (cur1cnt == 0)
+                              addToMap (request_inputs, "ResponseDocument",
+                                        (char *) val);
+                            else
+                              {
+                                map *tt =
+                                  getMap (request_inputs, "ResponseDocument");
+                                char *tmp = zStrdup (tt->value);
+                                free (tt->value);
+                                tt->value =
+                                  (char *)
+                                  malloc ((strlen (tmp) +
+                                           strlen ((char *) val) +
+                                           1) * sizeof (char));
+                                sprintf (tt->value, "%s;%s", tmp,
+                                         (char *) val);
+                                free (tmp);
+                              }
+                          }
+                        cur1cnt += 1;
+                        xmlFree (val);
+                      }
+            /**
 	     * Title, Asbtract
 	     */
-	    else if(xmlStrncasecmp(cur1->name,BAD_CAST "Title",xmlStrlen(cur1->name))==0 ||
-		    xmlStrncasecmp(cur1->name,BAD_CAST "Abstract",xmlStrlen(cur1->name))==0){
-	      xmlChar *val=
-		xmlNodeListGetString(doc,cur1->xmlChildrenNode,1);
-	      if(tmpmaps==NULL){
-		tmpmaps=(maps*)malloc(MAPS_SIZE);
-		if(tmpmaps == NULL){
-		  return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-		}
-		tmpmaps->name=zStrdup("missingIndetifier");
-		tmpmaps->content=createMap((char*)cur1->name,(char*)val);
-		tmpmaps->next=NULL;
-	      }
-	      else{
-		if(tmpmaps->content!=NULL)
-		  addToMap(tmpmaps->content,(char*)cur1->name,(char*)val);
-		else
-		  tmpmaps->content=createMap((char*)cur1->name,(char*)val);
-	      }
-	      xmlFree(val);
-	    }
-	    else if(xmlStrncasecmp(cur1->name,BAD_CAST "Output",xmlStrlen(cur1->name))==0){
-	      /**
+                    else
+                      if (xmlStrncasecmp
+                          (cur1->name, BAD_CAST "Title",
+                           xmlStrlen (cur1->name)) == 0
+                          || xmlStrncasecmp (cur1->name, BAD_CAST "Abstract",
+                                             xmlStrlen (cur1->name)) == 0)
+                      {
+                        xmlChar *val =
+                          xmlNodeListGetString (doc, cur1->xmlChildrenNode,
+                                                1);
+                        if (tmpmaps == NULL)
+                          {
+                            tmpmaps = (maps *) malloc (MAPS_SIZE);
+                            if (tmpmaps == NULL)
+                              {
+                                return errorException (m,
+                                                       _
+                                                       ("Unable to allocate memory."),
+                                                       "InternalError", NULL);
+                              }
+                            tmpmaps->name = zStrdup ("missingIndetifier");
+                            tmpmaps->content =
+                              createMap ((char *) cur1->name, (char *) val);
+                            tmpmaps->next = NULL;
+                          }
+                        else
+                          {
+                            if (tmpmaps->content != NULL)
+                              addToMap (tmpmaps->content, (char *) cur1->name,
+                                        (char *) val);
+                            else
+                              tmpmaps->content =
+                                createMap ((char *) cur1->name, (char *) val);
+                          }
+                        xmlFree (val);
+                      }
+                    else
+                      if (xmlStrncasecmp
+                          (cur1->name, BAD_CAST "Output",
+                           xmlStrlen (cur1->name)) == 0)
+                      {
+              /**
 	       * Get every attribute from a Output node
 	       * mimeType, encoding, schema, uom, asReference
 	       */
-	      const char *outs[5]={"mimeType","encoding","schema","uom","asReference"};
-	      for(int l=0;l<5;l++){
-#ifdef DEBUG
-		fprintf(stderr,"*** %s ***\t",outs[l]);
-#endif
-		xmlChar *val=xmlGetProp(cur1,BAD_CAST outs[l]);
-		if(val!=NULL && strlen((char*)val)>0){
-		  if(tmpmaps->content!=NULL)
-		    addToMap(tmpmaps->content,outs[l],(char*)val);
-		  else
-		    tmpmaps->content=createMap(outs[l],(char*)val);
-		}
-#ifdef DEBUG
-		fprintf(stderr,"%s\n",val);
-#endif
-		xmlFree(val);
-	      }
-	      xmlNodePtr cur2=cur1->children;
-	      while(cur2!=NULL && cur2->type != XML_ELEMENT_NODE)
-		cur2=cur2->next;
-	      while(cur2){
-		/**
+                        const char *outs[5] =
+                          { "mimeType", "encoding", "schema", "uom",
+                          "asReference"
+                        };
+                        for (int l = 0; l < 5; l++)
+                          {
+#ifdef DEBUG
+                            fprintf (stderr, "*** %s ***\t", outs[l]);
+#endif
+                            xmlChar *val =
+                              xmlGetProp (cur1, BAD_CAST outs[l]);
+                            if (val != NULL && strlen ((char *) val) > 0)
+                              {
+                                if (tmpmaps->content != NULL)
+                                  addToMap (tmpmaps->content, outs[l],
+                                            (char *) val);
+                                else
+                                  tmpmaps->content =
+                                    createMap (outs[l], (char *) val);
+                              }
+#ifdef DEBUG
+                            fprintf (stderr, "%s\n", val);
+#endif
+                            xmlFree (val);
+                          }
+                        xmlNodePtr cur2 = cur1->children;
+                        while (cur2 != NULL && cur2->type != XML_ELEMENT_NODE)
+                          cur2 = cur2->next;
+                        while (cur2)
+                          {
+                /**
 		 * Indentifier
 		 */
-		if(xmlStrncasecmp(cur2->name,BAD_CAST "Identifier",xmlStrlen(cur2->name))==0){
-		  xmlChar *val=
-		    xmlNodeListGetString(doc,cur2->xmlChildrenNode,1);
-		  if(tmpmaps==NULL){
-		    tmpmaps=(maps*)malloc(MAPS_SIZE);
-		    if(tmpmaps == NULL){
-		      return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-		    }
-		    tmpmaps->name=zStrdup((char*)val);
-		    tmpmaps->content=NULL;
-		    tmpmaps->next=NULL;
-		  }
-		  else{
-		    if(tmpmaps->name!=NULL)
-		      free(tmpmaps->name);
-		    tmpmaps->name=zStrdup((char*)val);;
-		  }
-		  xmlFree(val);
-		}
-		/**
+                            if (xmlStrncasecmp
+                                (cur2->name, BAD_CAST "Identifier",
+                                 xmlStrlen (cur2->name)) == 0)
+                              {
+                                xmlChar *val = xmlNodeListGetString (doc,
+                                                                     cur2->xmlChildrenNode,
+                                                                     1);
+                                if (tmpmaps == NULL)
+                                  {
+                                    tmpmaps = (maps *) malloc (MAPS_SIZE);
+                                    if (tmpmaps == NULL)
+                                      {
+                                        return errorException (m,
+                                                               _
+                                                               ("Unable to allocate memory."),
+                                                               "InternalError",
+                                                               NULL);
+                                      }
+                                    tmpmaps->name = zStrdup ((char *) val);
+                                    tmpmaps->content = NULL;
+                                    tmpmaps->next = NULL;
+                                  }
+                                else
+                                  {
+                                    if (tmpmaps->name != NULL)
+                                      free (tmpmaps->name);
+                                    tmpmaps->name = zStrdup ((char *) val);;
+                                  }
+                                xmlFree (val);
+                              }
+                /**
 		 * Title, Asbtract
 		 */
-		else if(xmlStrncasecmp(cur2->name,BAD_CAST "Title",xmlStrlen(cur2->name))==0 ||
-			xmlStrncasecmp(cur2->name,BAD_CAST "Abstract",xmlStrlen(cur2->name))==0){
-		  xmlChar *val=
-		    xmlNodeListGetString(doc,cur2->xmlChildrenNode,1);
-		  if(tmpmaps==NULL){
-		    tmpmaps=(maps*)malloc(MAPS_SIZE);
-		    if(tmpmaps == NULL){
-		      return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-		    }
-		    tmpmaps->name=zStrdup("missingIndetifier");
-		    tmpmaps->content=createMap((char*)cur2->name,(char*)val);
-		    tmpmaps->next=NULL;
-		  }
-		  else{
-		    if(tmpmaps->content!=NULL)
-		      addToMap(tmpmaps->content,
-			       (char*)cur2->name,(char*)val);
-		    else
-		      tmpmaps->content=
-			createMap((char*)cur2->name,(char*)val);
-		  }
-		  xmlFree(val);
-		}
-		cur2=cur2->next;
-		while(cur2!=NULL && cur2->type != XML_ELEMENT_NODE)
-		  cur2=cur2->next;
-	      }
-	    }
-	    cur1=cur1->next;
-	    while(cur1!=NULL && cur1->type != XML_ELEMENT_NODE)
-	      cur1=cur1->next;
-	  }
-	}
-	if(request_output_real_format==NULL)
-	  request_output_real_format=dupMaps(&tmpmaps);
-	else
-	  addMapsToMaps(&request_output_real_format,tmpmaps);
-	if(tmpmaps!=NULL){
-	  freeMaps(&tmpmaps);
-	  free(tmpmaps);
-	  tmpmaps=NULL;
-	}
-      }
-    xmlXPathFreeObject(tmpsptr);
-    xmlFreeDoc(doc);
-    xmlCleanupParser();
-  }
-  
-  runHttpRequests(&m,&request_input_real_format,&hInternet);
+                            else
+                              if (xmlStrncasecmp
+                                  (cur2->name, BAD_CAST "Title",
+                                   xmlStrlen (cur2->name)) == 0
+                                  || xmlStrncasecmp (cur2->name,
+                                                     BAD_CAST "Abstract",
+                                                     xmlStrlen (cur2->name))
+                                  == 0)
+                              {
+                                xmlChar *val = xmlNodeListGetString (doc,
+                                                                     cur2->xmlChildrenNode,
+                                                                     1);
+                                if (tmpmaps == NULL)
+                                  {
+                                    tmpmaps = (maps *) malloc (MAPS_SIZE);
+                                    if (tmpmaps == NULL)
+                                      {
+                                        return errorException (m,
+                                                               _
+                                                               ("Unable to allocate memory."),
+                                                               "InternalError",
+                                                               NULL);
+                                      }
+                                    tmpmaps->name =
+                                      zStrdup ("missingIndetifier");
+                                    tmpmaps->content =
+                                      createMap ((char *) cur2->name,
+                                                 (char *) val);
+                                    tmpmaps->next = NULL;
+                                  }
+                                else
+                                  {
+                                    if (tmpmaps->content != NULL)
+                                      addToMap (tmpmaps->content,
+                                                (char *) cur2->name,
+                                                (char *) val);
+                                    else
+                                      tmpmaps->content =
+                                        createMap ((char *) cur2->name,
+                                                   (char *) val);
+                                  }
+                                xmlFree (val);
+                              }
+                            cur2 = cur2->next;
+                            while (cur2 != NULL
+                                   && cur2->type != XML_ELEMENT_NODE)
+                              cur2 = cur2->next;
+                          }
+                      }
+                    cur1 = cur1->next;
+                    while (cur1 != NULL && cur1->type != XML_ELEMENT_NODE)
+                      cur1 = cur1->next;
+                  }
+              }
+            if (request_output_real_format == NULL)
+              request_output_real_format = dupMaps (&tmpmaps);
+            else
+              addMapsToMaps (&request_output_real_format, tmpmaps);
+            if (tmpmaps != NULL)
+              {
+                freeMaps (&tmpmaps);
+                free (tmpmaps);
+                tmpmaps = NULL;
+              }
+          }
+      xmlXPathFreeObject (tmpsptr);
+      xmlFreeDoc (doc);
+      xmlCleanupParser ();
+    }
+
+  runHttpRequests (&m, &request_input_real_format, &hInternet);
 
   //  if(CHECK_INET_HANDLE(hInternet))
-  InternetCloseHandle(&hInternet);
-
-#ifdef DEBUG
-  fprintf(stderr,"\n%d\n",__LINE__);
-  fflush(stderr);
-  dumpMaps(request_input_real_format);
-  dumpMaps(request_output_real_format);
-  dumpMap(request_inputs);
-  fprintf(stderr,"\n%d\n",__LINE__);
-  fflush(stderr);
+  InternetCloseHandle (&hInternet);
+
+#ifdef DEBUG
+  fprintf (stderr, "\n%d\n", __LINE__);
+  fflush (stderr);
+  dumpMaps (request_input_real_format);
+  dumpMaps (request_output_real_format);
+  dumpMap (request_inputs);
+  fprintf (stderr, "\n%d\n", __LINE__);
+  fflush (stderr);
 #endif
 
